/*
	PluginManager v4
	Copyright (C) 2011, plum

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// header
#include "plugin_mgr.h"

// global
int log_start;

// extern
extern char boot_path[256];

// function
int Log_printf(const char *format, ...)
{
	SceUID fd;
	va_list ap;
	int flags, len, res;
	char string[256], *log_path;

	switch(boot_path[0])
	{
		case 'm':	{ log_path = "ms0:/plugin_mgr_log.txt"; break; }
		case 'e':	{ log_path = "ef0:/plugin_mgr_log.txt"; break; }
		default:	return -1;
	}

	if(log_start != 1)
	{
		flags = PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC;
		log_start = 1;
	}
	else
	{
		flags = PSP_O_WRONLY | PSP_O_CREAT | PSP_O_APPEND;
	}

	// open
	fd = sceIoOpen(log_path, flags, 0777);

	if(fd < 0)
		return -1;

	va_start(ap, format);
	len = vsnprintf(string, 256, format, ap);
	va_end(ap);

	res = sceIoWrite(fd, string, len);
	sceIoClose(fd);

	return res;
}

